#!/usr/bin/perl
#
# dynamically extract ip address for named device on 1st line
# and ip address of default route on 2nd line.
# Create FA configuration based on this information.
#
# This is useful if you need to make a fa config file,
# and are sitting at home where your fa is getting a non-static
# Internet-side coa from a cable modem or dsl line.
#
# todo:
#  	syntax work:
#	# autofa.pl [-i ifname] [-r] [-f ifname mifname]
#		-i: print out i/f
#		-r: print out router
#		-f: print out simple fa config file
#			ifname  - name of interface to use for coa
#			mifname - name of interface to use for mobility
#
# note: only one switch at a time
# 	# autofa.pl -i ed0
#	# autofa.pl -r
#	# autofa.pl -f ed0 wi0
#
$switch = $ARGV[0];

if ($switch eq "-i") {
	$device = $ARGV[1];
	$if=getif();
	print "$if\n";
	exit(0);
}
elsif ($switch eq "-f") {
	$device = $ARGV[1];
	$if=getif();
	$fadevice = $ARGV[2];
	printfa_conf();
	exit(0);
}
elsif ($switch eq "-r") {
	$r=getrouter();
	print "$r\n";
	exit(0);
}

syntax();
exit(0);

sub syntax()
{
	printf("autofa.pl -i ifname: print out interface ip\n");
	printf("autofa.pl -r : print out default router ip\n");
	printf("autofa.pl -f ifname mifname: print out simple fa config file\n");
}

sub getif()
{
	
	open(CHECK, "ifconfig $device inet |");
	$ignore=<CHECK>;
        $_=<CHECK>;
    	chop;
    	($f1, $f2, $f3, $f4, $f5, $f6) = split;
	#print "$f2\n";
	close(CHECK);
	return($f2);
}

sub getrouter()
{
	
	open(CHECK, "netstat -rn | grep default|");
        $_=<CHECK>;
    	chop;
    	($f1, $f2, $f3, $f4, $f5, $f6) = split;
	close(CHECK);
	return($f2);
}

sub printfa_conf()
{
	print "fa $fadevice 255.255.255.255 arp\n";
	print "beacon 1\n";
	print "mobile_lifetime 120\n";
	print "coa $if\n";
}

