#!/bin/sh
# This script is used to make symlinks to compile mnd, mipd, etc.
# The basic idea is we have already compiled/installed KERNEL
# and we make /usr/include directories point at it.
# This script is only useful if FreeBSD and PSU/MIP have
# unreconciled kernel changes (currently true), and you
# wish to rebuild mnd/mipd, and/or make changes to them.
#
# these include the following set inclusive:
# net netinet netkey netsec sys machine
# assumption:  ln -s /usr/src/sys /sys

# move oldies aside
mv /usr/include/net /usr/include/net.old
mv /usr/include/netinet /usr/include/netinet.old
mv /usr/include/sys /usr/include/sys.old
mv /usr/include/machine /usr/include/machine.old

ln -s /sys/net /usr/include/net
ln -s /sys/netinet /usr/include/netinet
ln -s /sys/sys /usr/include/sys
ln -s /sys/i386/include /usr/include/machine
