#!/bin/sh
#sample shellscript for setting up a mobile-node
#this might be booted by hand or booted automagically post
#card insertion out of /etc/defaults/pccard.conf or override
#for that file

# first setup IPSEC policies if needed with setkey
# /etc/mn-ipsec.sh

# setup wireless card if any, e.g., lucent demo ad-hoc
# on channel 3
#wicontrol -i wi0 -p 3
#wicontrol -i wi0 -f 3
# OR new-fangled
# ifconfig ... 

# ipfw config if NAT is used
# or simply setup /etc/rc.firewall in /etc/rc.conf
# see INSTALL document on that.
ipfw add 100 pass all from any to any via lo0
ipfw add 200 deny all from any to 127.0.0.0/8
ipfw add 300 deny ip from 127.0.0.0/8 to any

# MUST IFCONFIG MOBILE INTERFACE BEFORE STARTING MND

# setup ip address for MN, include default route
# MN is 192.168.1.2, HA is default router, therefore 192.168.1.1
hostname kansas.cs.pdx.edu
ifconfig wi0 192.168.1.2 netmask 255.255.255.0
route delete default
route add default 192.168.1.1

# fireup mnd with config of choice 
# e.g., we assume arp configuration here
# note: mnd.conf must have correct interface in it 
# same as used above (e.g., wi0).

# note defaults to /etc/mnd.conf with no -c
mnd -c /etc/mnd.arp.conf
