
/*
 * Copyright (c) 1996 Portland State University 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Portland State University.
 * 4. The name of Portland State University may not be used to endorse 
 *    or promote products derived from this software without specific 
 *    prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR/S ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR/S BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/* packet structure info needed by fa/ha to manipulate
 * request/reply packets including variable extensions
 */
struct packet_info {
	char *packet;	/* pointer to packet buffer */
	int psize;	/* size of packet overall */
	struct udp_register *reg;
	struct udp_reply    *rep;
        int hasNat;	/* nat request found */
        int sendNatRep; /* need to send nat response */
	struct  sockaddr_in udp_src;     /* who sent the packet */
	u_short udp_port;		/* mn udp port */
  
	struct mse_authext  *mn_ha_auth; /* mn-ha mobileIP security ext. */
	int mn_ha_auth_size;
	int mn_ha_auth_count;
	int premnha_size;

	struct mse_authext  *fa_x_auth; /* fa-mn or fa-ha mobileIP sec. ext. */
        struct mse_nat_ext_req *nat_ext_req;
	struct mse_nat_ext_rep *nat_ext_rep; 
	int fa_x_auth_size;
	int fa_x_auth_count;
	int postmnha_size;

#ifdef HARP
	int forward;	/* harp forwarded packet flag */
	struct harpNat_ext *harp_nat_ext;
#endif

	int timeflag;		/* set to true to indicate TS nonce check */
};





