/* harp .h */

#ifndef _HARP
#define _HARP
 
#define ERROR		-1
#define HARP_DUMP_REQ   1   /* request for a vlist registration dump */
#define HARP_DUMP_REQ_SIZE     0 

#define HARP_REG_DUMP   2   /* a vlist registration dump message */
#define HARP_REG_DUMP_SIZE   8   /* a vlist registration dump message */
#define HARP_FORWARD	3   /* a forwarded MN registration packet */
#define HARP_FORWARD_SIZE	0   /* a forwarded MN registration packet */
#define HARP_PING	4   /* a co-HA ping message (Are you alive?) */
#define HARP_PING_SIZE	4   /* a co-HA ping message (Are you alive?) */
#define HARP_ACK	5  /* a co-HA ack message (Yes, I'm alive.) */
#define HARP_ACK_SIZE	4  /* a co-HA ack message (Yes, I'm alive.) */

#define HARP_PING_INTERVAL	10  /* number of ticks between pings */
#define HARP_ACK_TIMELIMIT	30  /* how many tick w/out an ack before *
			             * we assume the co-HA is dead   */	
#define HARPPACKETADD	8	/* addition to MAXUDPPACKET */

/* logically this is a MIP extension,
 * even though HARP needs it for NAT info.
 */
#define HARP_NAT_EXT    10

/* Harp-Nat Extension Info */
struct harpNat_ext {
	u_char           type;
	u_char		 size;	  
	u_short		 pad;		
	struct   in_addr natSrc;	/* "real" ip addr of nat box */
	u_short	         srcPort;	/* udp src port */
	u_short		 dstPort;	/* udp dst port */
};

void harpPing();
void harpAck();

#endif
