
/*
 * Copyright (c) 1996 Portland State University 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Portland State University.
 * 4. The name of Portland State University may not be used to endorse 
 *    or promote products derived from this software without specific 
 *    prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR/S ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR/S BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef MADRP

#include "sr_mad.h"

int srhlist_header(){
        printf("\nSR h list\n");
	printf("============================\n");
        printf("lifetime\tdestination\tnext hop\tmatric\tisAgent\n");
}

/*
 * print one srhlist entry out
 */
int
srhlist_dumpone(struct SR_hlist *v)
{
        printf("%d\t\t",v->lifetime);
	printf("%s\t",inet_ntoa(v->destHost));
	printf("%s\t",inet_ntoa(v->nextHop));
	printf("%d\t",v->metric);
	printf("%s\n", v->isAgent? "T":"F");
}

void dumpsr_metric(struct sr_metric sr_metric){
	printf("\nSR_packets thrown away due to:\n");
	printf("\tnot pass security check: \t%d\n", sr_metric.security);
	printf("\tttl decrement to zero: \t%d\n", sr_metric.ttl);
	printf("\thave loop in path tuples: \t%d\n", sr_metric.loop);
	printf("\thave received the same request ID (not for me): \t%d\n",
		sr_metric.samerequest);
	printf("\tsr_metric is not better than the old one: \t%d\n", 
		sr_metric.badmetric);
	printf("\tlater requests for same destination recved before: \t%d\n", 
		sr_metric.samedesti);
	printf("\ta reply/request sent by me: \t%d\n", sr_metric.myself);
	printf("\tpacket size too small: \t%d\n", sr_metric.size);
	printf("\thave loop among neighbours(link)\t%d\n",sr_metric.linkloop);
}

#endif
