
/*
 * Copyright (c) 1996 Portland State University 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Portland State University.
 * 4. The name of Portland State University may not be used to endorse 
 *    or promote products derived from this software without specific 
 *    prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR/S ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR/S BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


/*
 * error/logging stats for mipd
 */

struct ha_stats {
	int visitors;	/* number of vlist entries */
	int timeouts;   /* number of mns that timed out */
	int invalidmnauth;   /* mn did not have key in keylist */
	int missingmnauth;   /* number of invalid mn auth requests */
	int invalidfaauth;   /* number of invalid fa auth requests */
	int missingfaauth;   /* fa did not have key in keylist */
	int requests;	/* total requests recv. include dereg */
	int dereg;	/* number of deregistrations */
	int acks;	/* you may */
	int naks;	/* may not, total naks, should have kinds */
	int idmismatches;  /* time failures */
	int idspoofs;   /* possible time spoofs */
	int nonetauth;  /* UDP message but no mn net auth present */

	/* harp counters */
	int harpforward;	/* harpForward called */
	int harpforwrecv;	/* pkt recv. from harpForward */
	int harpudpinput;	/* any harp udp input packet */
	int harpping;	        /* saw HARP ping */
	int harpack;            /* saw HARP ping ACK */
	int harpdump;           /* individual registration during harp dump */
	int harpdumpnat;        /* during dump had registration with MIP nat ext. */
	int harpdumpharpnat;    /* during dump had registration with harp/nat ext. */
	int harpconnects;	/* harp dump connect attempts */
	int harpaccepts;	/* harp dump tcp accepts */
	int harpforwardhasnat;  /* harp forward has nat extension */
	int harpforwardhasharpnat; /* harp forward has harp/nat extension */
};


struct fa_stats {
	int pending;	/* number of pending mns */
	int visitors;	/* number of vlist entries */
	int timeouts;   /* number of mns that timed out */
	int badlifetime;  /* mn sent lifetime that was too big */
	int identmismatch;  /* ha reply doesn't match mn ident bits */
	int hadenied;  /* ha told mn that it failed */
	int replydropped;  /* number of replys with no mn */
	int invalidmnauth; /* number of invalid mn auth requests */
	int missingmnauth; /* mn lacks key and key required */
	int invalidhaauth; /* number of invalid ha auth requests */
	int missinghaauth; /* ha lacks key and key required */
	int requests;	/* total number of requests */
	int replies;    /* total number of replies */
	int nonetauth;  /* UDP message but no mn net auth present */
};

struct udp_errors {
	int badtype;	/* mobile ip udp payload - pkt type unknown */
	int regtooshort; /* reg packet too short */
	int repltooshort;  /* repl packet too short */
	int noauthent;	/* reg packet lacked mn ha authent extension */
	int badrequest;  /* ha got bogus request */
	int badreply;    /* ha got bogus reply */
	int hafaregistration;  /* ha sent fa registration ? */
	int fainvalidreg;  /* fa got registration across non-fa interface */
	int toomanyauthexts;  /* packet had > 1 authext of a type */
};
