/******************************************************
 * cMnStat.h
 * Header file for class cMnStat
 * Programmer: Ginny Mak
 * Location: Portland, Oregon
 * Date: Dec. 02, 2001
 ******************************************************/
#ifndef CMNSTAT_H
#define CMNSTAT_H

#include "iMnStat.h"
#include <netinet/in.h>
#include "../alist.h"
#include "../mnstats.h"
#include "../mnstate.h"
#include "../icmpstats.h"


/*****************************
 * class cMnStat             *
 *****************************/
class cMnStat : public virtual iMnStat{
public:
  cMnStat();
  ~cMnStat();
  
  int getBeaconData( char beaconFields[][10] );
  int getUdpData( char udpFields[][10] );
  int getState( mnstate *aMnState );
  int getAgents( int *count, char agentBeacon[][100],
		 int agentSignal[],
		 char agentLocation[][100] );
  int getNodes( int *count, char nodeBeacon[][100],
		int nodeSignal[],
		char nodeLocation[][100] );
  
private:
  bool mInitialized;
  char buf[1024];

  struct icmp_stats icmpstats; // for storing beacon statistics
  struct mn_stats mnstats;     // for storing udp statistics 
  struct mn_state mstate;      // for storing the current node's state
  struct alist agent;          // for storing surrounding agents' data
  struct alist node;           // for storing surrounding nodes' data

  // dump collected data into user-supplied data structure
  void dumpBeaconStats( char beaconFields[][10] );
  void dumpUdpStats( char udpFields[][10] );
  void dumpStateData( mnstate *aMnState );
  void dumpAgentData( int index, char *beacon,int *signal, char *location );
  void dumpNodeData( int index, char *beacon, int *signal, char *location );
};


#endif
