/* 
 * if_mvif.h
 *
 * ioctl calls to mvif device
 */
#ifndef	_MVIF_H
#define _MVIF_H

/* additional socket ioctl params for wl card   
 * see sys/sockio.h for numbers.  The 2nd params here
 * must be greater than any values in sockio.h
 */

#define SIOCGMVINIP	_IOWR('i', 62, struct ifreq) /* get inner ip */
#define SIOCSMVINIP	_IOWR('i', 63, struct ifreq) /* set inner ip */	
#define SIOCGMVOUTIP	_IOWR('i', 64, struct ifreq) /* get outer ip */	
#define SIOCSMVOUTIP	_IOWR('i', 65, struct ifreq) /* set outer ip */	

#ifdef _KERNEL

/* the one and only mvif structure.  There is no point in more
 * than one.  If and when soft state is implemented, it should
 * hang off of the route entries.
 */
extern struct       ifnet mvif;


#ifdef NOPE
static void		mvifattach __P((void *));
static int 		mvifioctl  __P((struct ifnet *, unsigned long, caddr_t));
#endif
int 			mvifoutput __P((struct ifnet *, struct mbuf *, 
				struct sockaddr *, struct rtentry *));
void 			mvifrtrequest __P((int,
				struct rtentry *, struct rt_addrinfo *));
#ifdef NOPE
static void		mvif_getifa __P((void));
#endif
struct in_ifaddr      *	mvif_requestia __P((void));
struct in_addr		mvif_getipaddr __P((void));

struct ifaddr 	      *	ifa_mip_tunnel __P((void));

#ifdef NRLIPSEC
struct mbuf 	      *	mvif_prependip __P((struct ifnet *, struct mbuf *,
				struct in_addr, struct in_addr, int *, int,
				struct key_tblnode *, struct key_tblnode *));
#else
struct mbuf 	      *	mvif_prependip __P((struct ifnet *, struct mbuf *,
				struct in_addr, struct in_addr, int *, int));
#endif /* NRLIPSEC */
#endif /* KERNEL */

#endif /* _MVIF_H */

